<?php
/**
* @package Joomla
* @subpackage Contact Form
* @copyright Copyright 2007, 2008 Brian Katzung, Kappa Computer Solutions, LLC.
* All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

if (!($acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'all' ) |
  $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'com_contactform' ))) 
{
        mosRedirect( 'index2.php', _NOT_AUTH );
	return;
}

global $task, $mainframe;

// load the HTML drawing class
require_once( $mainframe->getPath( 'admin_html' ) );
#require_once( $mainframe->getPath( 'class' ) );
cf_language();

//----------------------------------------------------------------------
// Main code - switch on task

switch ($task)
{
case 'remove':
	deleteMessages( josGetArrayInts( 'cid' ) );
	listMessages();
	break;

case 'view':
	viewMessage( $id );
	break;

default:
	listMessages();
	break;
}

//----------------------------------------------------------------------
// Include language file

function cf_language ()
{
	global $mosConfig_absolute_path, $mosConfig_lang;

	$lang = "$mosConfig_absolute_path/administrator/components/com_contactform/language";
	$p = "$lang/$mosConfig_lang.php";
	if ( file_exists( $p ) )
	{
		require_once( $p );
	}
	else
	{
		$p = "$lang/english.php";
		if ( file_exists( $p ) )
		{
			require_once( $p );
		}
	}
}

//----------------------------------------------------------------------
// Delete messages

function deleteMessages ( $list )
{
	global $database;

	$database->setQuery( "delete from #__cfmessage where id in (" .
	  join( ',', $list ) . ")" );
	$database->query();
}

//----------------------------------------------------------------------
// List saved messages

function listMessages ()
{
	global $database, $mainframe, $mosConfig_list_limit;

	$limit = intval( $mainframe->getUserStateFromRequest( "listlimit", "limit", $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "liststart", "limitstart", 0 ) );
	$database->setQuery( "select count(*) from #__cfmessage" );
	$total = $database->loadResult();

	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	$database->setQuery( "select * from #__cfmessage order by id",
	  $pageNav->limitstart, $pageNav->limit );
	$rows = $database->loadObjectList();

	HTML_contactform::listMessages( $rows, $pageNav );
}

//----------------------------------------------------------------------
// View a specific message

function viewMessage ( $id )
{
	global $database;

	$database->setQuery( "select * from #__cfmessage where id = $id" );
	$rows = $database->loadObjectList();

	HTML_contactform::viewMessage( $rows[0] );
}

// END
