<?php
/**
* @package Joomla
* @subpackage Contact Form
* @copyright Copyright 2007 Brian Katzung, Kappa Computer Solutions, LLC.
* All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );


class HTML_contactform
{
	function display ( $params, $contact_list )
	{
		global $mainframe;
		$labels = array();
		$values = array();
		$default = undefined;

		foreach ($contact_list as $contact)
		{
			if (substr( $contact[0], 0, 1 ) == '*')
			{
				$labels[] = substr( $contact[0], 1 );
				$default = $contact[1];
			}
			else
				$labels[] = $contact[0];
			$values[] = $contact[1];
		}

		if (!($query = $mainframe->get( 'CGI' )))
		{
			require_once('CGI.php');
			$mainframe->set( 'CGI', $query = new CGI() );
		}

		$status = $params->get( 'status' );
		if ($status != '')
			echo "<h2 class='cf_status'>", CF_STATUS, "</h2>\n",
			  $status;

		$cff_send_doc = $params->get( 'send_doc' );

		$ref = $query->hidden( array('name' => 'ref',
		  'value' => $_SERVER['HTTP_REFERER'], 'override' => 1) );
		$agent = $query->hidden( array('name' => 'agent',
		  'value' => $_SERVER['HTTP_USER_AGENT'], 'override' => 1) );
		$to_list = $query->popup_menu( array('name' => 'to',
		  'default' => $default, 'values' => $values,
		  'labels' => $labels) );
		$title = $query->textfield( array('name' => 'title', 'size' => 35) );
		$name = $query->textfield( array('name' => 'name', 'size' => 35) );
		$company = $query->textfield( array('name' => 'company', 'size' => 35) );
		$jobtitle = $query->textfield( array('name' => 'jobtitle', 'size' => 35) );
		$addr1 = $query->textfield( array('name' => 'addr1', 'size' => 35) );
		$addr2 = $query->textfield( array('name' => 'addr2', 'size' => 35) );
		$city = $query->textfield( array('name' => 'city', 'size' => 35) );
		$state = $query->textfield( array('name' => 'state', 'size' => 35) );
		$zip = $query->textfield( array('name' => 'zip', 'size' => 10) );
		$phone = $query->textfield( array('name' => 'phone', 'size' => 20) );
		$time = $query->textfield( array('name' => 'time', 'size' => 35) );
		$fax = $query->textfield( array('name' => 'fax', 'size' => 20) );
		$emaddr = $query->textfield( array('name' => 'emaddr', 'size' => 35) );
		$emaddr2 = $query->textfield( array('name' => 'emaddr2', 'size' => 35) );
		$send_doc = $query->checkbox( array('name' => 'send_doc', 'value' => 1) );
		$subject = $query->textfield( array('name' => 'subject', 'size' => 35) );
		$mesg = $query->textarea( array('name' => 'message',
		  'cols' => '50', 'rows' => '10', 'wrap' => 'hard') );

		switch ( $heading = $params->get( 'form_header' ) )
		{
		case '':
			$heading = CF_FORM_HEADING;
			break;
		case '[none]':
			$heading = '';
			break;
		case '[title]':
			$heading = $params->get( 'page_header' );
			break;
		}

		if ($heading != '')
			$heading = "<h2 class='cf_email'>$heading</h2>";

		$instruction = CF_FORM_INSTRUCTION;
		$cff_to = CF_FORM_TO;
		$cff_title = CF_FORM_TITLE;
		$cff_name = CF_FORM_NAME;
		$cff_company = CF_FORM_COMPANY;
		$cff_jobtitle = CF_FORM_JOBTITLE;
		$cff_address = CF_FORM_ADDRESS;
		$cff_city = CF_FORM_CITY;
		$cff_state = CF_FORM_STATE;
		$cff_zip = CF_FORM_ZIP;
		$cff_phone = CF_FORM_PHONE;
		$cff_phone_instr = CF_FORM_PHONE_INSTR;
		$cff_time = CF_FORM_TIME;
		$cff_fax = CF_FORM_FAX;
		$cff_email = CF_FORM_EMAIL;
		$cff_vfy_email = CF_FORM_VFY_EMAIL;
		$cff_time = CF_FORM_TIME;
		$cff_subject = CF_FORM_SUBJECT;
		$cff_mesg = CF_FORM_MESSAGE;
		$cff_send = CF_FORM_SEND;
		$cff_required = CF_FORM_REQUIRED;

		$pcs = $params->get( 'pageclass_sfx' );

		if ( !$params->get( 'embed_content' ) )
			echo "<form method='POST'>";

		echo <<<HTML
<table class="contentpaneopen$pcs">
<tr><td>$heading<p>$instruction</p>
<input type='hidden' name='task' value='send'>$ref
<div class='contact_form'>
<table class='contact_form'>

HTML;
		if ( count( $contact_list ) > 1 )
			echo "<tr><td>$cff_to</td><td>$to_list $cff_required</td></tr>\n";

		$fields = array();
		$field_list = explode( ' ', $params->get( 'field_list' ) );
		foreach ( $field_list as $field )
			$fields[$field] = 1;
		$fields['message'] = 1;

		foreach ( $fields as $field => $orig_todo )
		{
			// NB: Original to-do value may have changed.
			if (!$fields[$field])
				continue;

			if (substr($field, 0, 1) == '*')
			{
				$this_req = " $cff_required";
				$field = substr( $field, 1 );
			}
			else
				$this_req = '';

			$done = array( $field );
			switch ( $field )
			{
			case 'title':
				echo "<tr><td>$cff_title</td><td>$title$this_req</td></tr>\n";
				break;

			case 'name':
				echo "<tr><td>$cff_name</td><td>$name$this_req</td></tr>\n";
				break;

			case 'jobtitle':
				echo "<tr><td>$cff_jobtitle</td><td>$jobtitle$this_req</td></tr>\n";
				break;

			case 'company':
				echo "<tr><td>$cff_company</td><td>$company</td></tr>\n";
				break;

			case 'address':
			case 'csz':	# With city/state/zip
				echo "<tr><td rowspan='2'>$cff_address$this_req</td><td>$addr1</td></tr>\n";
				echo "<tr><td>$addr2</td></tr>\n";
				if ( $fields['csz'] )
				{
					echo <<<HTML
					<tr><td>$cff_city</td><td>$city</td></tr>
					<tr><td>$cff_state</td><td>$state</td></tr>
					<tr><td>$cff_zip</td><td>$zip</td></tr>

HTML;
				}

				$done = array( 'address', 'csz' );
				break;

			case 'phone':
				echo "<tr><td>$cff_phone</td><td>$phone$this_req</td></tr>\n";
				break;

			case 'phone+':	# (With instruction)
				echo "<tr><td>$cff_phone</td><td>$phone $cff_phone_instr$this_req</td></tr>\n";
				break;

			case 'fax':
				echo "<tr><td>$cff_fax</td><td>$fax$this_req</td></tr>\n";
				break;

			case 'email':
			case 'email2':	# (Verified)
				echo "<tr><td>$cff_email</td><td>$emaddr$this_req</td></tr>\n";
				break;

			case 'subject':
				echo "<tr><td>$cff_subject</td><td>$subject$this_req</td></tr>\n";
				break;

			case 'message':
				$this_req = $this_req? "<br />$cff_required": '';
				echo "<tr valign='top'><td>$cff_mesg$this_req</td><td>$mesg</td></tr>\n";
				break;

			case 'senddoc':
				if ($cff_send_doc != '')
					echo "<tr><td colspan='2'>$send_doc $cff_send_doc</td></tr>\n";
				break;
			}

			switch ( $field )
			{
			case 'phone':
			case 'phone+':
				if ( $fields['besttime'] )
					echo "<tr><td>$cff_time</td><td>$time</td></tr>\n";
				$done = array( 'phone', 'phone+' );
				break;

			case 'email':
			case 'email2':
				if ( $fields['email2'] || $fields['*email2'] )
					echo "<tr><td>$cff_vfy_email</td><td>$emaddr2$this_req</td></tr>\n";
				$done = array( 'email', 'email2' );
				break;
			}

			foreach ( $done as $field )
				$fields["*$field"] = $fields[$field] = 0;
		}

		echo <<<HTML
<tr><td>&nbsp;</td><td><input type='submit' value="$cff_send"></td></tr>
</table>
</div><!-- contact_form -->
</form>
</td></tr></table>

HTML;
	}

	function display_start ( $params )
	{
		if ( $params->get( 'embed_content' ) )
			echo "<form method='POST'>";
	}
}

// END
